/***************************************************************************
 *   Copyright (C) 2004-2009 by Michael Griffin                            *
 *   mrmisticismo@hotmail.com                                              *
 *                                                                         *
 *   Purpose:                                                              *
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// Enthral SVN: $Id: console.h 68 2009-05-20 09:46:22Z mercyful $
// Source: $HeadURL: http://svn.enthralbbs.com/trunk/src/console.h $
// $LastChangedDate: 2009-05-20 05:46:22 -0400 (Wed, 20 May 2009) $
// $LastChangedRevision: 68 $
// $LastChangedBy: mercyful $

#ifndef _CONSOLE
#define _CONSOLE

#include <sys/types.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>

#include <config.h>

struct olm {
    char olm_msg[200];
    int  olm_user;
    int  olm_number;
};

struct nodemessage {
    short  command;
    int     data1;
    int     data2;
    int     data3;
    char str[200];
};

extern int serhandle;
extern int sockfd;

int  init_nodes(void);
int  console_active(void);
int  init_console(void);
void open_console(void);
void close_console(void);
int  console_select_input(int, fd_set *);
int  console_pending_input(fd_set *);
int  console_getc(void);
int  console_putsn(void *, size_t);
void finalize_console(void);

#endif
