/***************************************************************************
 *   Copyright (C) 2004-2009 by Michael Griffin                            *
 *   mrmisticismo@hotmail.com                                              *
 *                                                                         *
 *   Purpose:                                                              *
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// Enthral SVN: $Id: msg_newscan.h 28 2009-04-01 07:10:30Z mercyful $
// Source: $HeadURL: http://svn.enthralbbs.com/trunk/src/msg_newscan.h $
// $LastChangedDate: 2009-04-01 03:10:30 -0400 (Wed, 01 Apr 2009) $
// $LastChangedRevision: 28 $
// $LastChangedBy: mercyful $

# ifndef MSG_NEWSCAN_H
# define MSG_NEWSCAN_H

# include "struct.h"

typedef struct msg_newscan {

	int  new_lockSet(int onoff);
	int  new_read(NewScan *ns, int idx, char *mbase);
	int  new_write(NewScan *ns, int idx, char *mbase);
	int  new_count(char *mbase);

	// Message NewScan Functions
	int  read_mbase(mb_list_rec *mr, int rec);
	int  check_mbase(UserRec *thisuser);


}msg_newscan;

# endif

