/***************************************************************************
 *   Copyright (C) 2004-2009 by Michael Griffin                            *
 *   mrmisticismo@hotmail.com                                              *
 *                                                                         *
 *   Purpose: BBS Config INI I/O                                           *
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// Enthral SVN: $Id: configbbs.h 68 2009-05-20 09:46:22Z mercyful $
// Source: $HeadURL: http://svn.enthralbbs.com/trunk/src/config.h $
// $LastChangedDate: 2009-05-20 05:46:22 -0400 (Wed, 20 May 2009) $
// $LastChangedRevision: 68 $
// $LastChangedBy: mercyful $


# ifndef __CONFIGBBS_H    /*  An extra safeguard to prevent this header from  */
# define __CONFIGBBS_H    /*  being included twice in the same source file    */

# include <string>

using namespace std;

/*--------------------------------------------------------------------------------*/
// Checks if CONFIG.CFG file exists
bool configdataexists();

/*--------------------------------------------------------------------------------*/
// Creat Defauly Config File if None Exists
void createconfig();

/*--------------------------------------------------------------------------------*/
// Parses Config File Data
void checkcfg(std::string cfgdata);

/*--------------------------------------------------------------------------------*/
// Read Config File
void parseconfig();

# endif

