/***************************************************************************
 *   Copyright (C) 2004-2009 by Michael Griffin                            *
 *   mrmisticismo@hotmail.com                                              *
 *                                                                         *
 *   Purpose:                                                              *
 *                                                                         *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// Enthral SVN: $Id: dtfunc.h 28 2009-04-01 07:10:30Z mercyful $
// Source: $HeadURL: http://svn.enthralbbs.com/trunk/src/dtfunc.h $
// $LastChangedDate: 2009-04-01 03:10:30 -0400 (Wed, 01 Apr 2009) $
// $LastChangedRevision: 28 $
// $LastChangedBy: mercyful $

# ifndef DTFUNC_H
# define DTFUNC_H

# include "stamp.h"

// Dos Time for Backwards MSGAPI Compability
time_t  StampToDosTime(struct _stamp *st);
struct  _stamp *DosTimeToStamp(time_t tt);

// Standard current time / date conversions.
char *getLastCallDays(unsigned long lastcall);
char *getAge(long sec);
int   VerifyBday(char *date);
char *Sec2DateTM(long time, int format);
char *Sec2Date(long sec);
long  Date2Sec(char *date);
long  GetCurrentDTSec();
long  GetTimeSec();

# endif
